<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>updateUser</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
<div class="container jumbotron">
    <div class="text-center mb-4">
        <!-- row 1 -->
        <h3>Chi tiết User</h3>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 2.1 -->
            <label>First Name</label>
        </div>
        <div class="col-sm-8">
            <!--col 2.2-->
            <input class="form-control" placeholder="Nhập firstname ..." id="input-firstname" type="text"/>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 3.1 -->
            <label>Last Name</label>
        </div>
        <div class="col-sm-8">
            <!--col 3.2-->
            <input class="form-control" placeholder="Nhập lastname ..." id="input-lastname" type="text"/>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 4.1 -->
            <label>Subject</label>
        </div>
        <div class="col-sm-8">
            <!--col 4.2-->
            <input class="form-control" placeholder="Nhập subject ..." id="input-subject" type="text"/>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 5.1 -->
            <label>Country</label>
        </div>
        <div class="col-sm-8">
            <!--col 5.2-->
            <select class="form-control" id="select-country" name="Customertype"/>
                <option value="VN">Việt Nam</option>
                <option value="USA">Mỹ</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
            </select>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 6.1 -->
            <label>Customer Type</label>
        </div>
        <div class="col-sm-8">
            <!--col 6.2-->
            <select class="form-control" id="select-customer-type" name="Customertype"/>
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
            </select>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 7.1 -->
            <label>Register Status</label>
        </div>
        <div class="col-sm-8">
            <!--col 7.2-->
            <select class="form-control" id="select-register-status" name="registerStatus"/>
                <option value="New">New</option>
                <option value="Accepted">Accepted</option>
                <option value="Denied">Denied</option>
            </select>
        </div>
    </div>
    <div class="row form-group">
        <div class="col-sm-4">
            <!--col 8.1 -->
        </div>
        <div class="col-sm-8">
            <!--col 8.2-->
            <button type="button" class="btn btn-success w-25" id="btn-update-user">
                Update User
            </button>
            <button type="button" class="btn btn-success w-25">Hủy bỏ
            </button>
        </div>
    </div>
</div>
</body>
<script>
    "use strict";
    /*** REGION 1 - GLOBAL variables */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";

    var gElementFirstName = $("#input-firstname");
    var gElementLastName = $("#input-lastname");
    var gElementSubject = $("#input-subject");
    var gElementCountry = $("#select-country");
    var gElementCustomerType = $("#select-customer-type");
    /*** REGION 2 - Vùng gán/ thực thi sự kiện cho các elements */
    $("#btn-update-user").click(function(){
        console.log("Update user clicked!");
        //B1: Get data
        var vDataObj = getFormData();
        //B2: validate data
        var vIsDataValid = validateFormData(vDataObj);
        if (vIsDataValid) {
        //B3: process update user info
        callAjaxAPIUpdateUser(vDataObj);
        }
    });

    /*** REGION 3 - Event handlers */
    // hàm thu thập dữ liệu
    function getFormData() {
        var vUpdateInfoObj = new Object();

        vUpdateInfoObj.firstname = $.trim(gElementFirstName.val());
        vUpdateInfoObj.lastname = $.trim(gElementLastName.val());
        vUpdateInfoObj.country = $.trim(gElementCountry.val());
        vUpdateInfoObj.customerType = gElementCustomerType.val();
        vUpdateInfoObj.subject = $.trim(gElementSubject.val());

        return vUpdateInfoObj;
    }

    // hàm kiểm tra dữ liệu
    function validateFormData(paramObjUserData) {
        if (paramObjUserData.firstname == "") {
            alert("Enter Firstname!");
            return false;
        }
        if (paramObjUserData.lastname == "") {
            alert("Enter Lastname!");
            return false;
        }
        if (paramObjUserData.subject == "") {
            alert("Enter Subject!");
            return false;
        }
        if (paramObjUserData.customerType == "") {
            alert("Enter CustomerType!");
            return false;
        }
        if (paramObjUserData.country == "") {
            alert("Enter Country!");
            return false;
        }
        return true;
    }
    // Hàm truy xuất và lấy dữ liệu Usẻr dựa vào UserId
    function callAjaxAPIUpdateUser(paramDataEditedObj) {
        "use strict";
        //B1: get data userId
        var vUserId = getCurrentUserId();
        //B2: validate data
        //B3: process get User list
        var vJsonString = JSON.stringify(paramDataEditedObj);
        console.log(vJsonString);
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + vUserId,
            method: "PUT",
            contentType: "application/json;charset=UTF-8",
            data: vJsonString,
            success: function (paramResponse) {
                // Thông báo cập nhật thành công
                alert("User ID:" + paramResponse.id + "Update User Data Sucessful");

                // Khi cập nhật thành công quay trở lại trang danh sách người dùng
                window.location.href = "list-users.html";

                console.log(JSON.stringify(paramResponse, true, 2));
            },
            error: function(ajaxContext){
                console.log(ajaxContext);
            }
        });
        }
    
    // Hàm thu thập UserId đang gửi request hiện tại
    function getCurrentUserId() {
        var vId = null;
        var vUrl = new URL(window.location.href); //vUrl tro thanh 1 object
        console.log(vUrl);
        //Get parameters
        vId = vUrl.searchParams.get("id");
        return vId;
    }
    // hàm được gọi khi load trang
    function onPageLoading() {
        "use strict";
        //thu thập dữ liệu từ query string
        var vUrlString = window.location.href;
        var vUrl = new URL(vUrlString);
        // get parameters
        var vId = vUrl.searchParams.get("id");
        console.log(vId);
        callAPIGetDataUserById(vId);
    }
     /*** REGION 4 - Common function */
     // hàm lấy thông tin user theo Id
     function callAPIGetDataUserById(paramUserId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            dataType: "json",
            success: function(DataUserObj) {
                console.log(DataUserObj);
                //gọi hàm hiển thị thông tin user lên form
                showDataUserToForm(DataUserObj);
            },
            error: function(ajaxContext) {
                alert(ajaxContext.responseText)
            },
        });
     }

     // hàm xử lý load dữ liệu lên form
     function showDataUserToForm(param) {
        "use strict";
        $("#input-firstname").val(param.firstname);
        $("#input-lastname").val(param.lastname);
        $("#select-country").val(param.country);
        $("#input-subject").val(param.subject);
        $("#select-customer-type").val(param.customerType);
        $("#select-register-status").val(param.registerStatus);
     }
</script>
</html>